unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, IdBaseComponent, IdComponent, IdRawBase, IdRawClient,
  IdIcmpClient;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    txtA: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    txtLastMessageTime: TEdit;
    txtLastMousePos: TEdit;
    txtFreeMem: TEdit;
    Label10: TLabel;
    txtFreeSwap: TEdit;
    Button2: TButton;
    ListBox1: TListBox;
    Label3: TLabel;
    txtHowMany: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    ListBox2: TListBox;
    function genRand(max: integer): integer;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  prevMousePos: integer;
  prevMessageTime: dword;


implementation

{$R *.DFM}

function TForm1.genRand(max: integer): integer;
var
   MS: TMemoryStatus;
   a: longint;
begin
   // ensure some time elapses & the mouse is moved
   // otherwise numbers could be repeated
   while (GetMessageTime = prevMessageTime) or (GetMessagePos = prevMousePos) do
      application.processmessages;

   // grab details of system memory
   GlobalMemoryStatus(MS);

   // save time of last Windows event and position of mouse cursor
   // we use these values to ensure they aren't repeated next time
   prevMessageTime := GetMessageTime;
   prevMousePos := GetMessagePos;

   // we just want the 7 least significant bits of the last event time as these are the most random
   a := (prevMessageTime and 127);

   // chuck in some data about the free memory & swap space for additional entropy
   // we only need the least significant stuff
   a := abs(a + (MS.dwAvailPageFile and 65535) + (MS.dwAvailPhys and 65535));

   // multiply this by the position of mouse cursor
   a := a * prevMousePos;

   // dump details to screen just for interest
   txtLastMessageTime.text := inttostr(prevMessageTime);
   txtLastMousePos.text := inttostr(prevMousePos);
   txtFreeMem.text := inttostr(MS.dwAvailPhys);
   txtFreeSwap.text := inttostr(MS.dwAvailPageFile);
   txtA.text := inttostr(abs(a));

   // fit result to max requested number
   result := abs(a mod (max+1));
end;

procedure TForm1.Button2Click(Sender: TObject);
const
   maxForStats = 65535;  // much higher & it just takes too long
var
   i, max, r: integer;
   stats: array of integer;
begin
   listbox2.Items.clear;
   listbox1.Items.clear;

   Button2.enabled := false;
   screen.cursor := crHourglass;
   max := strtoint(edit1.text);

   if max <= maxForStats then
      setlength(stats, max+1);

   for i := 1 to strtoint(txtHowMany.text) do
   begin
      r := genrand(max);
      if max <= maxForStats then
        inc(stats[r]);
      listbox2.items.append(inttostr(r));
      if listbox2.items.count > 30 then listbox2.items.clear;
      application.processmessages;
   end;

   if max <= maxForStats then
   begin
      for i := 0 to max do
         listbox1.Items.Add(inttostr(i) + '=' + inttostr(stats[i]));
   end;

   Button2.enabled := true;
   screen.cursor := crDefault;
end;

end.
